Bug 857860

Summary: ligatures in Calibri appear bold
Product: [Fedora] Fedora Reporter: Caolan McNamara <caolanm>
Component: freetypeAssignee: Marek Kašík <mkasik>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 17CC: behdad, fonts-bugs, kevin, mkasik, thumperward, wl
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-08-01 01:09:28 EDT Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Attachments:
Description Flags
screenshot
none
Screenshot from Windows
none
Windows "Standard" font smoothing
none
Windows "ClearType" font smoothing none

Description Caolan McNamara 2012-09-17 05:39:33 EDT
Created attachment 613610 [details]
screenshot

Description of problem:
With Calibri (11pt) ligatures are very noticeably visually different to surrounding text. They stand out as if bolded.

Version-Release number of selected component (if applicable):
rpm -q freetype fontconfig
freetype-2.4.8-3.fc17.x86_64
fontconfig-2.8.0-7.fc17.x86_64

How reproducible:
100%

Steps to Reproduce:
1. Install Calibri
2. Set font of gedit to Calibri 11pt
3. Type "anti off often little"
Comment 1 Behdad Esfahbod 2012-09-17 14:51:52 EDT
I suppose this is using the autohinter?  I would be surprised if that's the case in fact, but that's the only way to explain the bug.
Comment 2 Werner Lemberg 2012-09-17 15:24:40 EDT
This is not a bug.  The calibri font contains some bitmap strokes for small sizes (among them for 15ppem, which is your 11pt at 96dpi).  However, they are incomplete and cover only the latin1 glyph set.  Ligatures like `fi' or `ti' are not covered.  Additionally, the glyphs from the bitmap strokes are noticeably thinner.

If you want a consistent appearance, you have to disable bitmap strokes.
Comment 3 Behdad Esfahbod 2012-09-17 15:27:07 EDT
Ah, so it's a font bug.  I wonder what the rendering on Windows looks like then...
Comment 4 Behdad Esfahbod 2012-09-17 15:28:10 EDT
FWIW, we have had observed this same behavior with other, older, Microsoft fonts also.  We should assess completely disabling bitmaps by default.
Comment 5 Paul Flo Williams 2012-09-18 04:25:07 EDT
Created attachment 613895 [details]
Screenshot from Windows

Just out of interest, here is the rendering of Calibri in Firefox 3.6 on Windows XP with no font smoothing or ClearType. Somehow, it is getting consistent stroke widths.
Comment 6 Werner Lemberg 2012-09-18 05:09:30 EDT
Indeed, this is strange.  I have 5.62, and its `gasp' table says to do anti-aliasing even in the range 9<ppem<=19.  However, your image clearly shows that the font gets rendered in B/W mode, which is the only choice to get consistent results if you mix hinted glyphs with embedded bitmaps.  So the gasp table of my version is incorrect, it seems.

What version of Calibri are you using?  I can ask someone at Microsoft for clarification.
Comment 7 Caolan McNamara 2012-09-18 06:46:23 EDT
I have two versions of Calibri locally to test with, 1.02 and 5.62, but I get the same results with both.
Comment 8 Paul Flo Williams 2012-09-18 07:13:45 EDT
Created attachment 613978 [details]
Windows "Standard" font smoothing

Calibri version 5.62 on Windows XP with "Standard" font smoothing. Seems that the bitmap strikes aren't used at all?
Comment 9 Paul Flo Williams 2012-09-18 07:14:37 EDT
Created attachment 613979 [details]
Windows "ClearType" font smoothing

Calibri 5.62 on Windows XP with ClearType.
Comment 10 Behdad Esfahbod 2012-09-18 07:29:45 EDT
Ok, so what I think we need is to make FreeType / Fontconfig / Cairo etc implement these rules:

- Since bitmaps are binary images, only use embedded bitmaps if antialiasing is off.

- Respect gasp tables.

I like to see both be implemented at the FreeType's 'default' level, instead of apps having to worry about these.

Now, these may not fix this bug per se, but both sound like a step in the right direction.
Comment 11 Werner Lemberg 2012-09-18 07:33:31 EDT
Hmm.  FreeType is completely unaware of `gasp'.  Especially with the introduction of ClearType, handling of `gasp' has become non-trivial.  I would really like to not add this.
Comment 12 Werner Lemberg 2012-09-18 07:34:13 EDT
To be more specific, handling of `gasp' belongs into the same category as handling OpenType tables, this is, one level higher.
Comment 13 Werner Lemberg 2012-09-18 11:54:44 EDT
Greg Hitchcock replied as follows:

The simple answer is that the gasp table was designed for and only applies when font smoothing is enabled. 

The intention of the gasp table was to fine-tune the grayscale work. The Calibri font was initially only designed and hinted for ClearType, the gasp table settings and the sbit data was intended to *help* Calibri work better with either bi-level text or font smoothing.
Comment 14 Behdad Esfahbod 2012-09-25 00:07:37 EDT
(In reply to comment #11)
> Hmm.  FreeType is completely unaware of `gasp'.  Especially with the
> introduction of ClearType, handling of `gasp' has become non-trivial.  I
> would really like to not add this.

This is where we disagree :).  If it's non-trivial, it's even more non-trivial for FreeType-using pieces of the stack...


(In reply to comment #12)
> To be more specific, handling of `gasp' belongs into the same category as
> handling OpenType tables, this is, one level higher.

I wouldn't think so.  It directly affects rasterization, and as we have established in other threads, rasterizing using bytecode hinting with disregard to gasp table can be problematic.  Sure, we can force all FreeType users to implement gasp table handling, but I see it more fit in the library itself.
Comment 15 Fedora End Of Life 2013-07-03 21:03:11 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 16 Fedora End Of Life 2013-08-01 01:09:33 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.